Graphics 512,512,0

Global cols[5120]
Global font[5120]
Global img,img_i

fontI=LoadImageFont("Arial.ttf",24,BOLDFONT)
SetImageFont FontI


Filename$=RequestFile$( "Select Theme File","png",0)
If Lower$(Right$(filename$,4))=".png"

img=LoadPixmapPNG(filename$)
SetMaskColor(255,0,255)
img_i=LoadAnimImage(filename,144,32,0,30)

theme$=Left$(filename$,Len(filename$)-4)
If FileType(theme$)<>2 Then CreateDir(theme$)

CopyFile("Template/tester.html",theme$+"/tester.html")

ChangeDir(theme$)

If FileType("logo.gif")<>1
	CopyFile("../Template/logo.gif","logo.gif")
EndIf

If FileType("misc")<>2
	CreateDir("misc")
	DebugLog "Grabbing Template Misc"
	CopyFile("../Template/misc/dld.gif","misc/dld.gif")
	CopyFile("../Template/misc/moan1.gif","misc/moan1.gif")
	CopyFile("../Template/misc/nowt.gif","misc/nowt.gif")
	CopyFile("../Template/misc/quotein.gif","misc/quotein.gif")
	CopyFile("../Template/misc/quoteout.gif","misc/quoteout.gif")
	CopyFile("../Template/misc/unformat.gif","misc/unformat.gif")
EndIf

If FileType("buttons")<>2
	CreateDir("buttons")
	CopyFile("../Template/buttons/000-convert.bat","buttons/000-convert.bat")
EndIf

For x=0 To 2
For y=0 To 14
	GetCol(y,x)
	If x>0 Then GetFSize(y,x)
Next
Next


Parse("default2.css")
Button("Add Article",1)
Button("Add News",1)
Button("Comment",1)
Button("Delete",2)
Button("Edit",1)
Button("Logout",1)
Button("New Post",1)
Button("New Topic",1)
Button("Post Reply",1)
Button("Quote",1)
Button("Search",1)
Button("Update",1)
EndIf


Function Button(ftxt$,fi)
	Cls
	SetColor(255,0,255)
	DrawRect(0,0,512,512)
	SetColor(255,255,255)
	DrawImage(img_i,0,0,(fi*2)-1)
	SetColor(0,0,0)
	fx=72-(TextWidth(ftxt$)/2)
	fy=16-(TextHeight(ftxt$)/2)
	For o=0 To 2
	For n=0 To 360
		DrawText(ftxt$,fx+Sin(n)*o,fy-Cos(n)*o)
	Next
	Next
	
	
	SetColor(255,255,255)
	fx=72-(TextWidth(ftxt$)/2)
	fy=16-(TextHeight(ftxt$)/2)
	DrawText(ftxt$,fx,fy)

l=144
r=0
t=32
b=0
tmp=GrabPixmap(0,0,144,32)
For x=0 To 143
For y=0 To 31
If (ReadPixel(tmp,x,y) & $00FFFFFF)<>$00FF00FF
	If x<l Then l=x
	If x>r Then r=x
	If y<t Then t=y
	If y>b Then b=y
EndIf
Next
Next

l=l-1
t=t-1
b=b+1
r=r+1
If l<0 Then l=0
If r>143 Then r=143
If t<0 Then t=0
If b>31 Then b=31

tmp=GrabPixmap(l,t,(r-l)+1,(b-t)+1)
For x=0 To (r-l)
For y=0 To (b-t)

argb=ReadPixel(tmp,x,y)
cr=(argb & $00FF0000) Shr 16
cg=(argb & $0000FF00) Shr 8
cb=(argb & $000000FF)

If cr<16 And cg<16 And cb<16 Then argb=$FF0F000F
If (argb & $00FFFFFF)=$00FF00FF Then argb=$00000000
WritePixel(tmp,x,y,argb)
Next
Next

ftxt2$=Lower$(ftxt$)
ftxt2$=Replace(ftxt2$," ","_")
SavePixmapPNG(tmp,"buttons/"+ftxt2$+".png")
	
	Flip
	
End Function


Function Parse(file$)
quickin=ReadFile("../Template/"+file$)
quicky=WriteFile(file$)

Repeat
	in$=ReadLine(quickin)

For x=0 To 2
For y=0 To 14
	in$=Replace(in$,"C["+Chr$(y+65)+","+x+"];",col(y,x))
	in$=Replace(in$,"BG["+Chr$(y+65)+","+x+"];",BGCol(y,x))
	in$=Replace(in$,"F["+Chr$(y+65)+","+x+"];",fsize$(y,x))
	in$=Replace(in$,"FM["+Chr$(y+65)+","+x+"];",fsize$(y,x,1))
Next
Next

If in$="" Then in$=" "

	WriteLine(quicky,in$)
Until Eof(quickin)

CloseFile quicky

End Function




Function Col$(fink,ftype)
fr=cols[(((fink*5)+ftype)*5)]
fg=cols[(((fink*5)+ftype)*5)+1]
fb=cols[(((fink*5)+ftype)*5)+2]
Return "color : #"+Right$(Hex$(fr),2)+Right$(Hex$(fg),2)+Right$(Hex$(fb),2)+";"
End Function

Function BGCol$(fink,ftype)
fr=cols[(((fink*5)+ftype)*5)]
fg=cols[(((fink*5)+ftype)*5)+1]
fb=cols[(((fink*5)+ftype)*5)+2]

bfr=cols[(((fink*5)+(4))*5)]
bfg=cols[(((fink*5)+(4))*5)+1]
bfb=cols[(((fink*5)+(4))*5)+2]

out$="background-color: #"+Right$(Hex$(fr),2)+Right$(Hex$(fg),2)+Right$(Hex$(fb),2)+";"
If fink<>0 And fr=cols[(((0*5)+0)*5)] And fg=cols[(((0*5)+0)*5)+1] And fb=cols[(((0*5)+0)*5)+2]
	out$=""
EndIf

If bfr<>fr Or bfg<>fg Or bfb<>fb Then out$=out$+" border: 1px solid #"+Right$(Hex$(bfr),2)+Right$(Hex$(bfg),2)+Right$(Hex$(bfb),2)+";" 
Return out$
End Function

Function fsize$(fink,ftype,Monospace=0)
	out$=""
	
	out$="font-family: Tahoma, Geneva, sans-serif; "
	If Monospace=1 Then out$="font-family: Courier New; "
	size=font[(((fink*5)+ftype)*5)]
	If size<6 Then size=12
	out$=out$+" font-size:"+size+"pt;"
	
	
	bold=font[(((fink*5)+ftype)*5)+1]
	If bold=1 Then out$=out$+" font-weight: bold; "
	
	italic=font[(((fink*5)+ftype)*5)+2]
	If italic=1 Then out$=out$+" font-style: italic; "
	
	Return out$
End Function







Function GetCol(fink,ftype)
Local fy=fink
Local fx=ftype

	fy=((fy)*32)+27

	If ftype=0 Then fx=4
	If ftype=1 Then fx=17
	If ftype=2 Then fx=81
	
	argb=ReadPixel(img,fx,fy)
	
	cols[(((fink*5)+ftype)*5)]=(argb & $00FF0000) Shr 16
	cols[(((fink*5)+ftype)*5)+1]=(argb & $0000FF00) Shr 8
	cols[(((fink*5)+ftype)*5)+2]=(argb & $000000FF)

	If ftype=0
		ftype=4
		fx=0
		argb=ReadPixel(img,fx,fy)
		
		cols[(((fink*5)+ftype)*5)]=(argb & $00FF0000) Shr 16
		cols[(((fink*5)+ftype)*5)+1]=(argb & $0000FF00) Shr 8
		cols[(((fink*5)+ftype)*5)+2]=(argb & $000000FF)			
	EndIf

End Function



Function GetFSize(fink,ftype)
Local fy=fink
Local fx=ftype

	fy=((fy)*32)+27

	If ftype=0 Then fx=4
	If ftype=1 Then fx=16
	If ftype=2 Then fx=80

high=0
is=ReadPixel(img,fx,fy)
	
	For ex=0 To 31
		at=ReadPixel(img,fx+ex,fy)
		If at=is Then high=ex
	Next

	DebugLog fink+":"+ftype+":"+high
	font[(((fink*5)+ftype)*5)]=high+1
	font[(((fink*5)+ftype)*5)+1]=0
	font[(((fink*5)+ftype)*5)+2]=0
	
	If ReadPixel(img,fx+44,fy)=$FF000000 Then font[(((fink*5)+ftype)*5)+1]=1
	If ReadPixel(img,fx+52,fy)=$FF000000 Then font[(((fink*5)+ftype)*5)+2]=1

	
Return 12
End Function